
/**
 * Module dependencies.
 */

var atom = require('../lib/atom')
  , assert = require('assert')

var _print = require('./print');

// start date: Sat, 01 Oct 2011 13:30:00 GMT
var start = new Date(2011, 09, 1, 13, 30, 0)
// end date: Tue, 04 Oct 2011 20:40:00 GMT
  , end = new Date(2011, 09, 4, 20, 40, 0, 0)
  , updated = new Date(2011, 09, 5, 19, 55, 20, 0)

var objNormalEvent = {
        escription: ''
      , location: 'America/Argentina/Buenos_Aires'
      , _calendar: '4e8c6fdb7400eb9014000811'
      , _id: '4e8c6fdb7400eb9014000816'
      , _user: '4e4c2518e7a7cb911c000769'
      , created: 'Wed, 05 Oct 2011 14:55:23 GMT'
      , end: end
      , googleEtag: "E0gIRwZJeCp7JGA6WhJW"
      , googleId: '6cd3g8uhgave9gh2pm2g4d6bo4'
      , googleSelfLink: 'https://www.google.com/calendar/feeds/rdsuarez%40gmail.com/private/full/6cd3g8uhgave9gh2pm2g4d6bo4'
      , start: start
      , stop: 'Sun, 02 Oct 2011 03:00:00 GMT'
      , title: 'Normal Event'
      , updated: new Date()
      , google: true
      , allowRemoveTwins: true
      , recurrence: {
            exceptions: []
          , 'end-by': {
                type: 'never'
              , after: 1
            }
          , every: 1
        }
      , frequency: ''
      , allDay: false
    }

var xml_normal_event = '<entry xmlns="http://www.w3.org/2005/Atom" xmlns:gd="http://schemas.google.com/g/2005" xmlns:gCal="http://schemas.google.com/gCal/2005" gd:fields="gd:recurrence,gd:when"><title>Normal Event</title><gd:when startTime="2011-10-01T13:30:00.000Z" endTime="2011-10-04T20:40:00.000Z" /><gd:where valueString="America/Argentina/Buenos_Aires"></gd:where><updated>2011-10-05T19:55:20.000Z</updated></entry>';

/**
 * dump function to compare two xml string
 */

var compareXMLString = function (str1, str2, cut) {
  cut = cut || '\r\n';

  var arrStr1 = str1.split(cut)
    , arrStr2 = str2.split(cut);

  // length control
  if (arrStr1.length != arrStr2.length) {
    _print('error', 'array by split - length error', 'E', 'LIGHT_RED');
    return false;
  }

  var isOk = true;

  // line by line control
  for (var i = 0; i < arrStr1.length; i++) {
    var row1 = arrStr1[i]
      , row2 = arrStr2[i];

    isOk = (row1 == row2 || row1.match(/<\/updated/)) && isOk;

    if (!isOk) {
      _print('error', 'rows number ' + i + ' are not equal', 'E', 'LIGHT_RED');
      _print('', 'row1: ' + row1, '', 'RED');
      _print('', 'row2: ' + row2, '', 'RED');
      return false;
    }
    
  };

  return isOk;
};

module.exports = {

  'genEvent() - normal event': function (str) {
    _print('Atom\t', 'genEvent() - normal event');

    var string = atom.genEvent(objNormalEvent)
      , isOk = compareXMLString(xml_normal_event, string, '>');

    assert.ok(isOk, 'some recurrence property have an error');
  },

  'genEvent() - normal event - without location': function (str) {
    _print('Atom\t', 'genEvent() - normal event - without location');

    objNormalEvent.location = '';
    var tz = 'America/Argentina/Buenos_Aires';

    var string = atom.genEvent(objNormalEvent, tz)
      , isOk = compareXMLString(xml_normal_event, string, '>');

    assert.ok(isOk, 'some recurrence property have an error');
  }

};
